package com.baoyin.credit.cashloan.login.presenter

import android.os.Handler
import android.text.TextUtils
import baoyin.net.BYBnhuserServiceProto
import baoyin.net.BYCommonProto.UserSession
import com.baoyin.credit.base.BasePresenter
import com.baoyin.credit.base.activity.BaseActivity
import com.baoyin.net.pb.Params
import com.baoyin.net.pb.RequestManager
import com.baoyin.preference.ByxfApplication
import com.baoyin.preference.Constants
import com.baoyin.utils.GetServerTimeUtil
import com.baoyin.utils.Util
import com.byxf.app_lib_persistence.SharedPreUtils
import com.byxf.net.HttpRequest
import com.byxf.net.HttpService
import com.byxf.net.Observable
import com.byxf.net.Observer
import com.google.protobuf.GeneratedMessage

class RequireDevicePresenter(activity: BaseActivity) : BasePresenter(activity) {

    private var handler: Handler? = Handler()
    private var mPhone = ""
    private var mType = ""

    companion object {
        private var instance: RequireDevicePresenter? = null
        fun getRequirePresenter(activity: BaseActivity): RequireDevicePresenter {
            if (instance == null) {
                synchronized(RequireDevicePresenter::class.java) {
                    if (instance == null) {
                        instance = RequireDevicePresenter(activity)
                    }
                }
            }
            return instance!!
        }
    }

    fun requireDevice(phone: String, type: String) {
        mPhone = phone
        mType = type
        RequestManager.requireDevice(activity, this, phone, type)
    }

    private fun loop() {
        handler?.postDelayed({
            requireDevice(mPhone, mType)
        }, 10 * 1000)
    }

    override fun update(o: Observable<*>?, response: GeneratedMessage.Builder<out GeneratedMessage.Builder<*>>?, httpService: HttpService<out HttpRequest<*>, *>?, httpRequest: HttpRequest<*>?, observer: Observer<*>?) {
        super.update(o, response, httpService, httpRequest, observer)
        if (response != null) {
            if (response is BYBnhuserServiceProto.RequireDeviceResponse.Builder) {
                val requireDeviceResponse = response.build()
                val statusInfo = requireDeviceResponse.statusInfo
                if (statusInfo.code == Params.mCode) {
                    if ((TextUtils.equals(Constants.BQS, mType) && TextUtils.isEmpty(requireDeviceResponse.deviceKey))
                            || (TextUtils.equals(Constants.TD, mType) && TextUtils.isEmpty(requireDeviceResponse.tdDeviceId))) {
                        loop()
                    } else {
                        recycle()
                        //更新 ByxfApplication 里的UserSession
                        val tempUserSession = UserSession.newBuilder()
                                .setUserID(ByxfApplication.getBYuserSession().userID)
                                .setToken(ByxfApplication.getBYuserSession().token)
                                .setTimestamp(GetServerTimeUtil.getTime(activity.applicationContext))
                                .setDeviceKey(if (mType == Constants.BQS) requireDeviceResponse.deviceKey else ByxfApplication.getBYuserSession().deviceKey)
                                .setTdDeviceId(if (mType == Constants.TD) requireDeviceResponse.tdDeviceId else ByxfApplication.getBYuserSession().tdDeviceId)
                                .build()
                        ByxfApplication.userSession = tempUserSession
                        //CommonRequest 里使用
                        Util.saveUserSession(ByxfApplication.userSession, mContext)
                    }
                } else {
                    loop()
                }
            }
        }
    }

    fun recycle() {
        handler?.removeCallbacksAndMessages(null)
    }
}