package com.baoyin.credit.channel.activity

import android.os.Bundle
import android.support.v4.widget.SwipeRefreshLayout
import android.support.v7.widget.LinearLayoutManager
import android.view.View
import com.baoyin.credit.R
import com.baoyin.credit.base.activity.TitleBarActivity
import com.baoyin.credit.channel.action.IChannelEarlyRepayAction
import com.baoyin.credit.channel.adapter.ChannelToBePaidListAdapter
import com.baoyin.credit.channel.bean.ChannelEarlyRepayListBean
import com.baoyin.credit.channel.presenter.ChannelEarlyRepayPresenter
import com.baoyin.preference.Constants
import com.baoyin.utils.Util
import com.byxf.app_lib_persistence.SharedPreUtils
import kotlinx.android.synthetic.main.activity_channel_to_be_paid.*
import kotlinx.android.synthetic.main.activity_to_be_paid.*

/**
 * 全部待还页面
 */
class ChannelToBePaidActivity : TitleBarActivity(), ChannelToBePaidListAdapter.OnItemClickListener,
        IChannelEarlyRepayAction, SwipeRefreshLayout.OnRefreshListener {

    var mAdapter: ChannelToBePaidListAdapter? = null
    var linearLayoutManager: LinearLayoutManager? = null
    var mPresenter: ChannelEarlyRepayPresenter? = null
    private var earlyRepayList: MutableList<ChannelEarlyRepayListBean.EarlyRepayBean> = ArrayList<ChannelEarlyRepayListBean.EarlyRepayBean>()
    var channelCode: String = ""
    var custNo: String = ""

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_channel_to_be_paid)

        mAdapter = ChannelToBePaidListAdapter(this, this, earlyRepayList)
        linearLayoutManager = LinearLayoutManager(this)
        channel_to_be_paid_list.layoutManager = linearLayoutManager
        channel_to_be_paid_list.adapter = mAdapter
        channelCode = SharedPreUtils.getSharedPreferences(this, Constants.CHANNEL_HK_CODE, "")
        custNo = SharedPreUtils.getSharedPreferences(this, Constants.CHANNEL_CUST_NO, "")
        mPresenter = ChannelEarlyRepayPresenter(this, this, custNo, true, channelCode)
        channel_refresh_data.setOnRefreshListener(this)
    }

    /**
     * 获取待还列表成功
     */
    override fun getEarlyRepayListSuccess(earlyRepayBeanList: MutableList<ChannelEarlyRepayListBean.EarlyRepayBean>?) {
        channel_refresh_data.isRefreshing = false
        if (earlyRepayBeanList != null && earlyRepayBeanList.size > 0) {
            channel_empty_view.visibility = View.GONE
            earlyRepayList.clear()
            earlyRepayList.addAll(earlyRepayBeanList)
            mAdapter!!.notifyDataSetChanged()
        } else {
            channel_empty_view.visibility = View.VISIBLE
        }
    }

    /**
     * 列表点击事件
     */
    override fun onItemClick(position: Int) {
        val bundle = Bundle()
        bundle.putString("orderNo", earlyRepayList[position].orderNo)
        bundle.putString("channelCode", channelCode)
        Util.startActivity(this, ChannelTobePaidDetailActivity::class.java, bundle)
    }

    /**
     * 刷新数据
     */
    override fun onRefresh() {
        mPresenter!!.getEarlyRepayList(custNo, false, channelCode)
    }
}
